#ifndef __BTDRIVER_H__
#define __BTDRIVER_H__

#include "btwam.h"


/* structures defined in btwam.h */

/* typedef struct { */
/*   double q[7]; */
/* }wam_vector; */

/* typedef struct { */
/*      int id; */
/* 	double A,B,C,D,E,F; */
/* 	int Gcomp,Ocomp;*/  //0 = no gravity comp, 1 = gravity comp 
/* 	actuator_struct *act; */
/* 	int num_actuators; */
/* 	int wrist_attached; */ //0 no wrist, 1 yes wrist is attached. 
/* 	int motor_position[7]; */
/* 	int zero_order[7]; */
/* 	wam_vector zero_offsets; */
/* 	wam_vector stop_torque; */
/* 	wam_vector park_location; */
/* 	SimpleCtl sc[7]; */
/* 	wam_vector Mpos,Mtrq,Jpos,Jtrq; */
/* 	wam_vector Kp,Kd,Ki,saturation; */
/* 	wam_vector vel,acc; */
/*      double sample_rate; */
/* }wam_struct; */


int InitWAM(wam_struct *wamDriverDat, char *wamfile);
void CloseWAM();
SimpleCtl * GetWAMsc();
int LoadWAM(char *wamfile);
void SaveWAM(char *wamfile);
void DumpWAM2Syslog();
void WAMControlThread(void *data);

void PidWAM();
void TorqueWAM();
void PowerWAM();
void IdleWAM();

void SetWAMpos(wam_vector *wv);
void MoveWAM(wam_vector *pos, wam_vector *vel, wam_vector *acc);
void ParkWAM();

void ZeroWAM();

typedef int (*TorqueEffector)(wam_struct *, void *);

void deregisterTorqueEffector(int index);
int registerTorqueEffector(TorqueEffector torqueEffector);



#endif
