/*
   Module .............libbt                                
   File ...............control_loop.h                                     
   Author .............Traveler Hauptman                                 
   Creation Date ......Nov 23, 2002                                 
                                                                       
              Copyright (c) 2002 Barrett Technology, Inc.              
                         139 Main Street                               
                        Kendall/MIT Square                             
                   Cambridge, MA  02142-1528  USA                      
                                                                      
                         All rights reserved.                          
                                                                       
 ***********************************************************************
 *                            DISCLAIMER                               *
 *                                                                     *
 *  This software and related documentation are provided to you on     *
 *  an as is basis and without warranty of any kind.  No warranties,   *
 *  express or implied, including, without limitation, any warranties  *
 *  of merchantability or fitness for a particular purpose are being   *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett    *
 *  Technology, Inc. be liable for any lost development expenses, lost *
 *  lost profits, or any incidental, special, or consequential damage. *
 *                                                                     *
 ***********************************************************************  
 *                                                                      
 *  NOTES:                                                              
 *   Infrastructure to simplify adding and using your own control threads. 
 *                                                                      
 *  REVISION HISTORY:                                                   
 *  021123 - TH - File created                                          
 *                                                                      
 *======================================================================*/

 /* \file control_loop.h
    \brief Infrastructure to simplify adding and using your own control threads.
    
    This module adds code to start up timing threads that will call a user specified 
  control thread at regular intervals.
    
   
*/ 
#ifndef _CONTROL_H
#define _CONTROL_H
#ifdef __cplusplus
extern "C"
{
#endif/* __cplusplus */
#include "btsystem.h"
#include "SimpleControl.h"

  
typedef struct 
{
  int num_act;
  actuator_struct *act;
  SimpleCtl *sc;
}control_thd_parms;

void start_control_threads(int priority, long sample_period, void *function,void *args);
void stop_control_threads();
void TimerThread();
void ControlThread(void *data);

#ifdef __cplusplus
}
#endif/* __cplusplus */
#endif _CONTROL_H


/*======================================================================*
 *                                                                      *
 *             Copyright (c) 2003 Barrett Technology, Inc.              *
 *                        139 Main Street                               *
 *                       Kendall/MIT Square                             *
 *                  Cambridge, MA  02142-1528  USA                      *
 *                                                                      *
 *                        All rights reserved.                          *
 *                                                                      *
 *  ******************************************************************  *
 *                            DISCLAIMER                                *
 *                                                                      *
 *  This software and related documentation are provided to you on      *
 *  an as is basis and without warranty of any kind.  No warranties,    *
 *  express or implied, including, without limitation, any warranties   *
 *  of merchantability or fitness for a particular purpose are being    *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett     *
 *  Technology, Inc. be liable for any lost development expenses, lost  *
 *  lost profits, or any incidental, special, or consequential damage.  *
 *  ******************************************************************  *
 *                                                                      
 * CVS info: $Id$
 * CVS automatic log (prune as desired):
 * $Log$
 *
 *======================================================================*/