/*
   Module .............libbt                                
   File ...............doubblebuffer.c                                     
   Author .............Traveler Hauptman                                 
   Creation Date ......April 3, 2002                                 
                                                                       
              Copyright (c) 2002 Barrett Technology, Inc.              
                         139 Main Street                               
                        Kendall/MIT Square                             
                   Cambridge, MA  02142-1528  USA                      
                                                                      
                         All rights reserved.                          
                                                                       
 ***********************************************************************
 *                            DISCLAIMER                               *
 *                                                                     *
 *  This software and related documentation are provided to you on     *
 *  an as is basis and without warranty of any kind.  No warranties,   *
 *  express or implied, including, without limitation, any warranties  *
 *  of merchantability or fitness for a particular purpose are being   *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett    *
 *  Technology, Inc. be liable for any lost development expenses, lost *
 *  lost profits, or any incidental, special, or consequential damage. *
 *                                                                     *
 ***********************************************************************  
 *                                                                      
 *  NOTES:                                                              
 *   Uses some code & concepts developed at Nortwestern University 
 *   by Traveler Hauptman                                                                      
 *  REVISION HISTORY:                                                   
 *                                           
 *                                                                      
 *======================================================================*/

/* Data logger data structures
There are two buffers and a pointer to the current one with
and index and a state variable to determine whether the
other buffer has been written.
*/
#ifndef _DOUBLEBUFFER_H
#define _DOUBLEBUFFER_H
#include <syslog.h>
#include <stdio.h>
#include <stdlib.h>
typedef struct
{
  double Pos[7];
}
data_to_log;

typedef struct
{
  data_to_log *DL,*DLbuffer1,*DLbuffer2;
  int DLidx;
  int DLwritten;       //0 all buffers clear, 1 buffer1 ready, 2 buffer2 ready
  int DLctr;
  int Log_Data;
  int Log_File_Open;
  int buffersize;
  FILE *DLfile;
}DoubleBuffer_struct;

int InitDL(DoubleBuffer_struct *db,int size, char *filename);
void DLon(DoubleBuffer_struct *db);
void DLoff(DoubleBuffer_struct *db);
void CloseDL(DoubleBuffer_struct *db);
data_to_log * GetDLptr(DoubleBuffer_struct *db);
void InitDataFile(DoubleBuffer_struct *db);
void UpdateDL(DoubleBuffer_struct *db);
void DLwrite(DoubleBuffer_struct *db);
void evalDL(DoubleBuffer_struct *db);
void flushDL(DoubleBuffer_struct *db);
#endif _DOUBLEBUFFER_H
