/*
   Module .............QNXpuck                                
   File ...............globals.h                                          
   Author .............Traveler Hauptman                                 
   Creation Date ......Dec 03, 2002                                 
                                                                       
              Copyright (c) 2002 Barrett Technology, Inc.              
                         139 Main Street                               
                        Kendall/MIT Square                             
                   Cambridge, MA  02142-1528  USA                      
                                                                      
                         All rights reserved.                          
                                                                       
 ***********************************************************************
 *                            DISCLAIMER                               *
 *                                                                     *
 *  This software and related documentation are provided to you on     *
 *  an as is basis and without warranty of any kind.  No warranties,   *
 *  express or implied, including, without limitation, any warranties  *
 *  of merchantability or fitness for a particular purpose are being   *
 *  provided by Barrett Technology, Inc.  In no event shall Barrett    *
 *  Technology, Inc. be liable for any lost development expenses, lost *
 *  lost profits, or any incidental, special, or consequential damage. *
 *                                                                     *
 ***********************************************************************  
 *                                                                      
 *  NOTES:                                                              
 *  Global variables
 *  Useful defines
 *  Wrapper functions                  
 *                                                                      
 *  REVISION HISTORY:                                                   
 *  021203 - TH - File created                                          
 *                                                                      
 *======================================================================*/

 /*! \file globals.h  
    \brief Global variables, useful defines, etc
    
    
*/

#ifndef _GLOBALS_H
#define _GLOBALS_H

/********************* Defines **********************/
#define EPOCH                 500000L           ///< epoch in nanosecond; should be 499504, but ClockPeriod() errors with anything less than 500000
#define SAMPLETIME            999008L          ///<  DT in nanoseconds - an integer multiple of EPOCH     

#define TWOPI 6.283185

#define fer(_x_,_y_) for (_x_ = 0;_x_ < _y_;_x_++)
#define Border(Value,Min,Max)  (Value<Min)?Min:((Value>Max)?Max:Value)
#endif _GLOBALS_H
/********************* Defines **********************/
