#ifndef __KINEMATICS_H__
#define __KINEMATICS_H__

#include "btwam.h"

#define MASSTEST


#ifdef MASSTEST
#define MAXDOF 8
#else
#define MAXDOF 4
#endif

typedef struct {

  double pos[3];
  double angle[3];

} WAMLoc;


typedef struct {

  double transforms[MAXDOF][16];
  double As[MAXDOF];
  double Ds[MAXDOF];
  double Alphas[MAXDOF];
  int dof;

} WAMKinematics;



void findDHtransform_deltaTheta(WAMKinematics *wamKin, wam_vector *inputAngles);

void initLinkTransform(double alpha, double a, double theta, double d, double *transform);

void InitKinematics(WAMKinematics *wamKin, int dof);





#endif
